//+------------------------------------------------------------------+
//|                                                ChimeraSimple.mq4 |
//+------------------------------------------------------------------+

extern int        TakeProfit              = 999;
extern double     Lots                    = 0.1;
extern bool       TrailingStop            = true;
extern string     C_Signal1               = "====== Parabolic SAR =================================";
extern double     P_SARStep               = 0.02; 
extern double     P_SARMax                = 0.2; 
extern double     P_EnvDev                = 0.1; 
//extern string     C_Signal2               = "====== Money Flow Index ========================";
//extern int        P_MFIBPer               = 13;
//extern int        P_MFIRPer               = 34;
extern string     C_Signal4               = "====== Average True Range ======================";
extern int        P_ATRPer                = 5;
extern int        P_ATRMin                = 1;
extern int        P_ATRMax                = 30;
//extern string     C_Signal5               = "====== Standard Deviation ==========================";
//extern int        P_STDPer                = 5; 
//extern int        P_STDMin                = 1;
//extern int        P_STDMax                = 30;
//extern string     C_Signal6               = "====== Stochastic Oscillator ====================";
extern int        P_SORPer                = 13; 
extern int        P_SOYPer                = 34; 
extern int        P_SOSlow                = 5; 
//extern string     C_Signal7               = "====== Average Directional Index ==========================";
//extern int        P_ADXPer                = 13; 
//extern int        P_ADXMin                = 10;
//extern int        P_ADXMax                = 20;
//extern string     C_Signal8               = "====== Relative Strength Index ========================";
//extern int        P_RSIBPer               = 13;
//extern int        P_RSIRPer               = 34;
extern string     C_Signal9               = "====== Force Index ========================";
//extern int        P_ForceSlow             = 13;
extern int        P_STDFPer               = 13;
extern int        P_STDFMin               = 10;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables

//  Calculates the Parabolic Stop and Reverse system
    double PSAR0 = iSAR(NULL,0,P_SARStep,P_SARMax,0);    
    double PSAR1 = iSAR(NULL,0,P_SARStep,P_SARMax,1); 

//  Envelope 5 Upper and Lower Channels are defined
    double ENVU0 = iEnvelopes(NULL,0,5,MODE_SMMA,0,PRICE_MEDIAN,P_EnvDev,MODE_UPPER,0);
    double ENVL0 = iEnvelopes(NULL,0,5,MODE_SMMA,0,PRICE_MEDIAN,P_EnvDev,MODE_LOWER,0);

//  MA 2 Linear weighted - weighted Close
    double MAV0 = iMA (NULL,0,1,0,MODE_LWMA,PRICE_WEIGHTED,0);   //MA 2 Linear weighted -  Wighted or Close.  now
    double MAV1 = iMA (NULL,0,1,0,MODE_LWMA,PRICE_WEIGHTED,1);   //MA 2 Linear weighted -  Wighted or Close.  1 bar ago
//Print("MoveAve0 = ", MAV0);
//Print("MoveAve1 = ", MAV1);

// Money Flow Index hybrid volume indicator
//    double MFIB0 = iMFI(NULL,0,13,0);
//    double MFIB1 = iMFI(NULL,0,13,1);
//    double MFIR0 = iMFI(NULL,0,34,0);
//    double MFIR1 = iMFI(NULL,0,34,1);

 
//  MA 5 Upper and Lower Channels are defined
//    double PACUpp0 = iMA(NULL,0,5,0,MODE_SMMA,PRICE_HIGH,0);  //MA 5 PRICE_HIGH now
//    double PACUpp1 = iMA(NULL,0,5,0,MODE_SMMA,PRICE_HIGH,1);  //MA 5 PRICE_HIGH 1 bar ago
    
//    double PACLow0 = iMA(NULL,0,5,0,MODE_SMMA,PRICE_LOW,0);   //MA 5 PRICE_LOW now
//    double PACLow1 = iMA(NULL,0,5,0,MODE_SMMA,PRICE_LOW,1);   //MA 5 PRICE_LOW 1 bar ago
    
//  Heiken Ashi Close     
//    double haClose0 = (Open[0]+High[0]+Low[0]+Close[0])*(0.25);      //Heiken Ashi Close now
//    double haClose1 = (Open[1]+High[1]+Low[1]+Close[1])*(0.25);      //Heiken Ashi Close 1 bar ago
//Print("HeikenAshi0 = ", haClose0);
//Print("HeikenAshi1 = ", haClose1);


//  13 per Stochastic Oscillator, Signal Mode EMA, High/Low, variable Slow Signal per  
    double SOB0  = iStochastic(NULL,0,13,P_SORPer,P_SOSlow,MODE_EMA,0,MODE_MAIN,0);
    double SOB1  = iStochastic(NULL,0,13,P_SORPer,P_SOSlow,MODE_EMA,0,MODE_MAIN,1);
    double SOR0 = iStochastic(NULL,0,13,P_SORPer,P_SOSlow,MODE_EMA,0,MODE_SIGNAL,0);
    double SOR1 = iStochastic(NULL,0,13,P_SORPer,P_SOSlow,MODE_EMA,0,MODE_SIGNAL,1);
    double SOY0 = iStochastic(NULL,0,13,P_SOYPer,P_SOSlow,MODE_EMA,0,MODE_SIGNAL,0);
    double SOY1 = iStochastic(NULL,0,13,P_SOYPer,P_SOSlow,MODE_EMA,0,MODE_SIGNAL,1);
//    Print("SOS0 value = ",SOS0);
//    Print("SOM0 value = ",SOM0);

// Standard Deviation and Average True Range filters
//    double STD0 = iStdDev(NULL,0,P_STDPer,0,MODE_EMA,PRICE_WEIGHTED,0);
//    double STD1 = iStdDev(NULL,0,P_STDPer,0,MODE_EMA,PRICE_WEIGHTED,1);
    double ATR0 = iATR(NULL,0,P_ATRPer,0);
//    double ATR1 = iATR(NULL,0,P_ATRPer,1);


// Relative Strength Index
//         double RSIB0 = iRSI(NULL,0,P_RSIBPer,PRICE_WEIGHTED,0);
//         double RSIB1 = iRSI(NULL,0,P_RSIBPer,PRICE_WEIGHTED,1);
//         double RSIR0 = iRSI(NULL,0,P_RSIRPer,PRICE_WEIGHTED,0);
//         double RSIR1 = iRSI(NULL,0,P_RSIRPer,PRICE_WEIGHTED,1);

// Average Directional Index
//            double ADXM0 = iADX (NULL, 0, P_ADXPer,PRICE_MEDIAN,MODE_MAIN,0);
//            double ADXM1 = iADX (NULL, 0, P_ADXPer,PRICE_MEDIAN,MODE_MAIN,1);
//            double ADXP0 = iADX (NULL, 0, 13,PRICE_MEDIAN,MODE_PLUSDI,0);
//            double ADXP1 = iADX (NULL, 0, 13,PRICE_MEDIAN,MODE_PLUSDI,1);
//            double ADXS0 = iADX (NULL, 0, 13,PRICE_MEDIAN,MODE_MINUSDI,0);
//            double ADXS1 = iADX (NULL, 0, 13,PRICE_MEDIAN,MODE_MINUSDI,1);

      double Force[];
      ArrayResize(Force,14);
      ArraySetAsSeries(Force,true);
      for(int k=0; k<=13; k++)
      {
         Force[k]= (iForce(NULL,0,13,MODE_EMA,PRICE_TYPICAL,k));
      }
         double FFast0 = iForce(NULL,0,13,MODE_EMA,PRICE_TYPICAL,0);
         double FFast1 = iForce(NULL,0,13,MODE_EMA,PRICE_TYPICAL,1);
//       double FFast0 = iMAOnArray(Force,0,P_ForceFast,0,MODE_EMA,0);
//       double FFast1 = iMAOnArray(Force,0,P_ForceFast,0,MODE_EMA,1);
//       double FSlow0 = iMAOnArray(Force,0,P_ForceSlow,0,MODE_EMA,0);
//       double FSlow1 = iMAOnArray(Force,0,P_ForceSlow,0,MODE_EMA,1);
       double STDF0 =  iStdDevOnArray(Force,0,P_STDFPer,0,MODE_EMA,0);
       double STDF1 =  iStdDevOnArray(Force,0,P_STDFPer,0,MODE_EMA,1);

           
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      // Entry-Rules for LONG positions:
      // 1. MAV > upper PAC moving average AND
      // 2. PAC moving average trending up AND
      // 3. TDI: RSI (green line) > 50 and TSL (red line) and MBL (yellow line) AND
      // 4. TDI: RSI (green line) < 68
//          ignore >50 <68, add Force, Standard Deviation and Parabolic SAR confirmation
      if(
//----------------------Price Action Channel Breakout----------------------
//                  MAV0  >  PACUpp0
//              && PACUpp0  >  PACUpp1
//----------------------Stochastic Oscillator------------------------
//                  SOB0  >  SOR0
//               && SOB0  >  SOY0
                  SOB0  >  SOB1
               && SOR0  >  SOR1
               && SOY0  >  SOY1
               && P_SOYPer  >  P_SORPer
//----------------------Parabolic SAR and Envelope Filter---------------------
               && PSAR0 <  ENVL0
//----------------------Standard Deviation------------------------
//               && STD0  >  STD1
//               && STD0  >  (P_STDMin*Point)
//               && STD0  <  (P_STDMax*Point)
//----------------------Average True Range------------------------
//               && ATR0  >  ATR1
               && ATR0  >  (P_ATRMin*Point)
               && ATR0  <  (P_ATRMax*Point)
//----------------------Relative Strength Index------------------------
//               && RSIB0 >  RSIR0
//               && RSIB0 >  RSIB1
//               && RSIR0 >  RSIR1
//----------------------Money Flow Index------------------------
//               && MFIB0 >  MFIB1
//               && MFIR0 >  MFIR1
//----------------------Average Directional Index------------------
//               && ADXP0   > ADXS0
//               && ADXM0   > ADXM1
//               && ADXM0   > P_ADXMin
//               && ADXM0   < P_ADXMax
//----------------------Force Index------------------------
               && FFast0     >  FFast1    
//               && FFast0     >  FSlow0    
//               && FSlow0     >  FSlow1
               && STDF0   >  STDF1
               && STDF0   >  (P_STDFMin*Point)

        )
        
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      // Entry-Rules for SHORT positions:
      // 1. MAV < lower PAC moving average AND
      // 2. PAC moving average trending down AND
      // 3. TDI: RSI (green line) < 50 and TSL (red line) and MBL (yellow line) AND
      // 4. TDI: RSI (green line) > 32 
//          ignore <50 >32, add Force, Standard Deviation and Parabolic SAR confirmation

      if(
//----------------------Price Action Channel Breakout----------------------
//                  MAV0  <  PACLow0
//               && PACLow0  <  PACLow1
//----------------------Stochastic Oscillator------------------------
//                  SOB0  <  SOR0
//               && SOB0  <  SOY0
                  SOB0  <  SOB1
               && SOR0  <  SOR1
               && SOY0  <  SOY1
              && P_SOYPer  >  P_SORPer
//----------------------Parabolic SAR and Envelope Filter---------------------
               && PSAR0 >  ENVU0
//----------------------Standard Deviation------------------------
//               && STD0  >  STD1
//               && STD0  >  (P_STDMin*Point)
//               && STD0  <  (P_STDMax*Point)
//----------------------Average True Range------------------------
//               && ATR0  >  ATR1
               && ATR0  >  (P_ATRMin*Point)
               && ATR0  <  (P_ATRMax*Point)
//----------------------Relative Strength Index------------------------
//               && RSIB0 <  RSIR0
//               && RSIB0 <  RSIB1
//               && RSIR0 <  RSIR1
//----------------------Money Flow Index------------------------
//               && MFIB0 <  MFIB1
//               && MFIR0 <  MFIR1
//----------------------Average Directional Index------------------
//               && ADXS0   > ADXP0
//               && ADXM0   > ADXM1
//               && ADXM0   > P_ADXMin
//               && ADXM0   < P_ADXMax
//----------------------Force Index------------------------
               && FFast0     <  FFast1    
//               && FFast0     <  FSlow0    
//               && FSlow0     <  FSlow1
               && STDF0   >  STDF1
               && STDF0   >  (P_STDFMin*Point)
         )
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            // Exit-Rules for LONG positions:
            // 1. Positive bar is much shorter than the previous bar or changes to a negative bar at close OR
            // 2. Bar closes inside the channel OR
            // 3. TDI: RSI (green line) crosses back below the RSL (red line) AND
            // 4. TDI: RSI > 68 AND
            // 5. TDI: RSI crosses back below the upper volatility band to the downside.
            // replace condition 4 by change of direction of Force moving averages
            // add Parabolic SAR exit instead of stop loss.
            if(
                (   PSAR1 <  MAV1
                 && PSAR0 >  MAV0
                )
                || (
                     SOR0  <  SOR1
                  && SOB0  <  SOB1
                  && STDF0 <  STDF1
//                  && RSIB0 <  RSIB1
//                  && STD0  <  STD1
                    )
               )
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop TS HANDLED BY PSAR
            if(TrailingStop==true)  
//              {                 
//               if(Bid-OrderOpenPrice()>Point*TrailingStop)
//                 {
//                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),PSAR0,OrderTakeProfit(),0,Green);
                     return(0);
                    }
//                 }
//              }
           }
         else // go to short position
           {
            // should it be closed?
            // Exit-Rules for SHORT positions:
            // 1. Negative bar is much shorter than the previous bar or changes to a positive bar at close OR
            // 2. Bar closes inside the channel OR
            // 3. TDI: RSI (green line) crosses back above the RSL (red line) AND
            // 4. TDI: RSI < 32 AND
            // 5. TDI: RSI crosses back above the lower volatility band to the upside.
            // replace condition 4 by change of direction of Force moving averages
            // add Parabolic SAR exit instead of stop loss.
            if( 
                (   PSAR1 >  MAV1
                 && PSAR0 <  MAV0
                )
                || (
                     SOR0  >  SOR1
                  && SOB0  >  SOB1
                  && STDF0 <  STDF1
//                  && RSIB0 >  RSIB1
//                  && STD0  <  STD1
                  )
               )
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop TS HANDLED BY PSAR
            if(TrailingStop==true)  
//              {                 
//               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
//                 {
//                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),PSAR0,OrderTakeProfit(),0,Red);
                     return(0);
                    }
//                 }
//              }
           }
        }
     }
   return(0);
  }
// the end.